local Camera = require "examples/vendor/hump/camera"
local LightWorld = require "lib"
require("videolib/videolib")
require "player"
require "texture"
require "map"
local utils = require("ArchUtils")
-- require "mob"

function love.load()

	-- CAMERA & WORLD 
	
	xworld = 0
	yworld = 0
	scaleworld = 1
	cam = Camera(love.graphics.getWidth()/2, love.graphics.getHeight()/2)
	
	love.mouse.setVisible(false)

	lightWorld = LightWorld({
		ambient = {0,0,0},
		refractionStrength = 0.0,
		reflectionVisibility = 0.0,
	})

	lightMouse = lightWorld:newLight(255, 255, 255, 255, 255, 200)
	lightMouse:setGlowStrength(50)

	lightRange = 98

	gamestate = "GAME"

	width = 0
	height = 0
	
	-- AMBIENT 
	
	daycircle = 1
	
	sun = {
	  i = love.graphics.newImage('gfx/sun.png'),
	  x = 0,
	  y = 0,
	}
	moon = {
	  i = love.graphics.newImage('gfx/moon.png'),
	  x = 0,
	  y = 0,
	}
	if daycircle > 0 and daycircle < 10 then
		sun.l = lightWorld:newLight(255, 255, 255, 255, 255, 1000000000)
		sun.l:setGlowStrength(0)
	end
	if daycircle > 9 and daycircle < 20 then
		sun.l = lightWorld:newLight(100, 100, 100, 100, 100, 1000000000)
		sun.l:setGlowStrength(0)
	end
	
	sky = {
	  light = {},
	  num = 0,
	  bolean = {},
	  check = {},
	}
	sky.bolean[sky.num] = false

	-- PHYSICS
	
	-- ball = {}
		-- ball.size = 16
        -- ball.b = love.physics.newBody(world, 400,200, "dynamic")
        -- ball.s = love.physics.newCircleShape(ball.size)
        -- ball.f = love.physics.newFixture(ball.b, ball.s)
        -- ball.f:setRestitution(0) 
        -- ball.f:setUserData("Ball")
	-- square = {}
		-- square.width = 32
		-- square.height = 32
		-- square.b = love.physics.newBody(world, 400, 300, "dynamic")
		-- square.s = love.physics.newRectangleShape(square.width, square.height)
		-- square.f = love.physics.newFixture(square.b, square.s)
		-- square.f:setUserData("Square")
	-- square2 = {}
		-- square2.width = 32
		-- square2.height = 32
		-- square2.b = love.physics.newBody(world, 450, 300, "dynamic")
		-- square2.s = love.physics.newRectangleShape(square2.width, square2.height)
		-- square2.f = love.physics.newFixture(square2.b, square2.s)
		-- square2.f:setUserData("Square2")
	-- square3 = {}
		-- square3.width = 32
		-- square3.height = 32
		-- square3.b = love.physics.newBody(world, 400, 350, "dynamic")
		-- square3.s = love.physics.newRectangleShape(square3.width, square3.height)
		-- square3.f = love.physics.newFixture(square3.b, square3.s)
		-- square3.f:setUserData("Square3")
	
	timer = 0
	
	mapLoad()

	-- OTHER 
	
	randomation = math.random(0,love.graphics.getWidth())
	
	nuage = {}
	nuage.width = 100
	nuage.height = 30
	for x = -100, nuage.width do
		nuage[x] = {}
		for y = 0, nuage.height do
			if x < 1 then
				nuage[x][y] = math.random(0,math.random(0,1))
			end
		end
	end
	
	nuage2 = {}
	nuage2.number = 0
	nuage2.i = {}
	nuage2.i[nuage2.number] = love.graphics.newImage('gfx/nuage.png')
	
	
	playerw.frames.prefix = "gfx/player/Animation marche/Hero nu_000"
	playerw.frames.postfix = ".png"
	playerw.frames.total = 59
	playerw.frames.fps = 25
	playerw.start()
	
	nuagespeed = 0
	
	timernuage = 0
	
	mapUpdate()
	
end

function love.update(dt)
	love.window.setTitle("UnviPlanet (FPS:" .. love.timer.getFPS() .. ") GAMESTATE:"..gamestate.." ENERGY:"..player.energy)

	player.x = player.b:getX()
	player.y = player.b:getY()
	player.b:setAngle(0)
	
	timer = timer+dt
	
    world:update(dt)
	mapUpdate()
	
	width = love.graphics.getWidth()
	height = love.graphics.getHeight()
	
	-- square.b:setAngle(0)
	-- square2.b:setAngle(0)
	-- square3.b:setAngle(0)
	player.b:setAngle(0)

	player.energy = player.energy + dt*15
	if player.energy >= player.energyall then
		player.energy = player.energyall
	else end
	if player.energy < 0 then
		player.energy = 0
	else end

	if daycircle > 20 then
		daycircle = 0
	end
	
	if love.keyboard.isDown("down") then
		yworld = yworld - dt * 200
	elseif love.keyboard.isDown("up") then
		yworld = yworld + dt * 200
	end

	if love.keyboard.isDown("right") then
		xworld = xworld - dt * 200
	elseif love.keyboard.isDown("left") then
		xworld = xworld + dt * 200
	end

	if love.keyboard.isDown("-") then
		scaleworld = scaleworld - 0.01
	elseif love.keyboard.isDown("=") then
		scaleworld = scaleworld + 0.01
	end

	if gamestate == "GAME" then
		player:move()
		if love.keyboard.isDown('d') or love.keyboard.isDown('q') then
			playerw.update(dt)
			if playerw.frame > 58 then
				playerw.frame = 1
			end
		end
	end
	
	--sun.l:setPosition(xworld, yworld)
	lightMouse:setPosition((love.mouse.getX() - xworld)/scaleworld, (love.mouse.getY() - yworld)/scaleworld)

	cam:lookAt(xworld, yworld)
	cam:zoom(scaleworld)
	lightWorld:setTranslation(xworld, yworld, scaleworld)

	local x = love.mouse.getX() - xworld/scaleworld
	local y = love.mouse.getY() - yworld/scaleworld

	local mapX = math.floor(y/32)
	local mapY = math.floor(x/32)
	if love.mouse.isDown('l') and y > 1*32 and x > 1*32 and mapCollide(x, y) < 1 and ( map[mapX+1][mapY] > 0 or map[mapX-1][mapY] > 0 or map[mapX][mapY+1] > 0 or map[mapX][mapY-1] > 0 ) then
		for y = 0, map.height do
			for x = 0, map.width do
				map[mapX][mapY] = 1
				if map[x][y] == 1 then
					-- if dirt.y ~= mapY then
						-- dirt.y = dirt.y + 1 end
					-- if dirt.x ~= mapX then
						-- dirt.x = dirt.x + 1 end
					-- if mapX == dirt.x and mapY == dirt.y then
						dirt.b = love.physics.newBody(world, mapY*32, mapX*32, "static")
						dirt.s = love.physics.newRectangleShape(32,32)
						dirt.f = love.physics.newFixture(dirt.b, dirt.s)
						dirt.f:setUserData("Dirt"..dirt.x..dirt.y)
						-- dirt.i[dirt.y][dirt.x] = lightWorld:newImage(dirtimg, (mapY+0.5)*32, (mapX+0.5)*32, 32, 32)
						-- dirt.bolean[dirt.n] = true
					-- else dirt.y = dirt.y + 1 dirt.x = dirt.x + 1 end  
				else end  
				-- mapUpdate()
			end
		end
	end
  local mx = math.floor((love.mouse.getX() - xworld/scaleworld)/32) --ADDED, we make mapx, mapy
	local my = math.floor((love.mouse.getY() - yworld/scaleworld)/32)
  --ADDED, i think of it as mouse x (mx) and mouse y (my)
	if love.mouse.isDown('r') and y > 1*32 and x > 1*32 then
		-- for y = 0, map.height do
			-- for x = 0, map.width do
				if map[mx][my] == 1 then
        --ADDED :
          --we fetch working item at that location under dirt type
          --we then use the body (.b) and call destroy on it
					local working_item = map_items.dirt[mx][my]
          if(working_item) then --ADDED does it exist? empty space or unknown item will result in false here.
            if(working_item.b) then
              working_item.b:destroy()
              working_item.f:destroy()
            end
            
            map_items.dirt[mx][my] = nil -- ADDED clear up the space?
          end
				elseif map[mx][my] == 2 then
          --ADDED :
          --we fetch working item at that location under stone type
          --we then use the body (.b) and call destroy on it
					local working_item = map_items.stone[mx][my]
          if(working_item) then --ADDED does it exist? empty space or unknown item will result in false here.
            working_item.b:destroy()
            working_item.f:destroy()
            map_items.stone[mx][my] = nil  -- ADDED clear up the space?
          end
				elseif map[mx][my] == 0 then end
				map[mapX][mapY] = 0
			end
		-- end
	-- end
	
end

function love.draw()
	cam:attach()
		lightWorld:draw(function()
			love.graphics.setColor(255, 255, 255)
			love.graphics.rectangle("fill", -xworld/scaleworld, -yworld/scaleworld, love.graphics.getWidth()/scaleworld, love.graphics.getHeight()/scaleworld)
			if daycircle > 0 and daycircle < 10 then
				love.graphics.draw(day, -xworld/scaleworld, -yworld/scaleworld, 0)
				love.graphics.draw(sun.i, -xworld/scaleworld, -yworld/scaleworld, 0, 0.5)
			end
			if daycircle > 9 and daycircle < 20 then
				love.graphics.draw(night, -xworld/scaleworld, -yworld/scaleworld, 0)
				love.graphics.draw(stars, -xworld/scaleworld, -yworld/scaleworld, 0)
				love.graphics.draw(moon.i, -xworld/scaleworld, -yworld/scaleworld, 0, 0.5)
			end
			
			--love.graphics.draw(arbre, 0, 65, 0, 0.5)
			--love.graphics.draw(arbre, 300, 65, 0, 0.5)
			--love.graphics.draw(arbre, 500, 65, 0, 0.5)
			
			-- love.graphics.setColor(255, 255, 255)
			-- love.graphics.circle("fill", ball.b:getX()+16,ball.b:getY()+16, ball.s:getRadius(), 500)
			-- love.graphics.setColor(255, 255, 255)
			-- love.graphics.rectangle('fill', square.b:getX()-(square.width/2)+16, square.b:getY()-(square.height/2)+16, square.width, square.height, square.b:getAngle())
			-- love.graphics.setColor(255, 255, 255)
			-- love.graphics.rectangle('fill', square2.b:getX()-(square2.width/2)+16, square2.b:getY()-(square2.height/2)+16, square2.width, square2.height, square2.b:getAngle())
			-- love.graphics.setColor(255, 255, 255)
			-- love.graphics.rectangle('fill', square3.b:getX()-(square3.width/2)+16, square3.b:getY()-(square3.height/2)+16, square3.width, square3.height, square3.b:getAngle())
			
			player:draw()
			-- mob:draw()
			
			mapDraw()
			
			if gamestate == "PAUSE" then
				love.graphics.setColor(0, 0, 0, 100)
				love.graphics.rectangle("fill", xworld, yworld, love.graphics.getWidth(), love.graphics.getHeight())
				love.graphics.setColor(255, 255, 255)
			end
			
			x = love.mouse.getX() - xworld/scaleworld
			y = love.mouse.getY() - yworld/scaleworld
			
			local mapX = math.floor(x/32) -- ADDED
			local mapY = math.floor(y/32) --these were wrong way round, confused debug data.
			
			love.graphics.draw(cursor, x, y)
			
			love.graphics.print("X:"..mapX, 5, 5)
			love.graphics.print("Y:"..mapY, 5, 20)
			love.graphics.print("LOOK X:"..dirt.lookx, 5, 35)
			love.graphics.print("LOOK Y:"..dirt.looky, 5, 50)			
			love.graphics.print("DIRT NUMBER Y:"..dirt.x, 5, 65)
			love.graphics.print("DIRT NUMBER X:"..dirt.y, 5, 80)
		end)
	cam:detach()
end

function beginContact(a, b, coll)
	
end
 
function endContact(a, b, coll)
 
end
 
function preSolve(a, b, coll)
 
end
 
function postSolve(a, b, coll, normalimpulse1, tangentimpulse1, normalimpulse2, tangentimpulse2)
 
end
